; =============================================================================================
; ShowInfo and ShowInt...
; =============================================================================================
; tabs  : 8 spaces (See Lesson_1 for beginning)
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include WinCmn.inc      ; Common include files and our definitions
; =============================================================================================
; Standard C functions
; --------------------
        _itoa           proto c value:dword, buffer:dword, base:dword
; =============================================================================================
; public and externals
; ======================
extrn   szMsgCaption    : byte
public  szCmnBuffer     ; make it public - to be used in other parts
; =============================================================================================
.data
; Common
        szCmnBuffer     db 256 dup(?)
; =============================================================================================
.code
; =============================================================================================
; Helpers
; ==============
ShowInfo        proc lpszText:dword

        invoke  ShowMessage, lpszText, addr szMsgCaption
        ret
ShowInfo        endp
; ---------------------------------------------------------------------------------------------
ShowMessage     proc lpszText:dword, lpszCaption:dword

        invoke  MessageBox, NULL, lpszText, lpszCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
; ++
IntToString     proc value:dword, buffer:dword, base:dword

        invoke  _itoa, value, buffer, base
        ret
IntToString     endp
; ---------------------------------------------------------------------------------------------
ShowInteger     proc value:dword, base:dword

        invoke  IntToString, value, addr szCmnBuffer, base
        invoke  ShowInfo, eax     ; eax - addr szCmnBuffer
        ret
ShowInteger     endp
; =============================================================================================
ShowBinInt      proc value:dword

        invoke  ShowInteger, value, 2
        ret
ShowBinInt      endp
; ---------------------------------------------------------------------------------------------
ShowDecInt      proc value:dword

        invoke  ShowInteger, value, 10
        ret
ShowDecInt      endp
; ---------------------------------------------------------------------------------------------
ShowHexInt      proc value:dword

        invoke  ShowInteger, value, 16
        ret
ShowHexInt      endp
; =============================================================================================
end
