; =============================================================================================
; tabs  : 8 spaces
; =============================================================================================
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; ---------------------------------------------------------------------------------------------
        includelib \masm32\lib\msvcrt.lib       ; standard c library
; ---------------------------------------------------------------------------------------------
; our libraries
        includelib WinCmn.lib
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm

        ShowSeg macro   reg
                push    reg
                call    ShowHexInt
        endm
; =============================================================================================
; Helpers
; ----------------------
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword
; ++
        IntToString     proto value:dword, buffer:dword, base:dword
        ShowInteger     proto value:dword, base:dword

        ShowBinInt      proto value:dword
        ShowDecInt      proto value:dword
        ShowHexInt      proto value:dword
; =============================================================================================
