// ============================================================================================
// Test for AsmDll.dll - SumInt(a, b) and SubInt(a, b) - see in AsmDll.asm
// ============================================================================================
using System;					// Console,...
using System.Drawing;			// Color,...
using System.Collections;		// ArrayList,...
using System.Runtime.InteropServices;	// [DllImport]
// --------------------------------------------------------------------------------------------
class TheApp
{
	public static void Main(string[] args)
	{
		Console.WriteLine("1 + 2 = " + SumInt(1, 2));
		Console.WriteLine("5 - 2 = " + SubInt(5, 2));

		// Exit :
		PressEnterToExit();
	}

	[DllImport("AsmDll.dll")]			// , CallingConvention = CallingConvention.StdCall
	static extern Int32 SumInt(Int32 a, Int32 b);

	[DllImport("AsmDll.dll")]			// , CallingConvention = CallingConvention.StdCall
	static extern Int32 SubInt(Int32 a, Int32 b);

	// Helpers
	static void PressEnterTo(string strTo)
	{
		Console.WriteLine("Press Enter to {0}", strTo);
		Console.ReadLine();
	}

	static void PressEnterToExit() { PressEnterTo("Exit"); }
}
// ============================================================================================
/*
CallingConvention:
-------------------
	Name		Value
	------------------
	Winapi		1
	Cdecl		2
	StdCall 	3
	ThisCall	4
	FastCall	5
*/
// ============================================================================================
