; =============================================================================================
; tabs  : 8 spaces
; ---------------------------------------------------------------------------------------------
        .386                    ; from .386, 32 bits code is the same upto Pentium
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows - WinAPI)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; basic definitions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; =============================================================================================
.data
        szMsgText       db "Message", 0         ; ending by zero string
        szMsgCaption    db "Dialog Caption", 0

; =============================================================================================
; Local prototypes
; ================
        WinMain         proto

; =============================================================================================
.code
start:
        invoke  WinMain
        invoke  ExitProcess, 1  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
WinMain proc                    ; where working code is located
; code
        invoke  MessageBox, NULL, addr szMsgText, addr szMsgCaption, MB_OK
        ret
WinMain endp
; =============================================================================================
end     start
