; =============================================================================================
; tabs  : 8 spaces
; ---------------------------------------------------------------------------------------------
        .386                    ; from .386, 32 bits code is the same upto Pentium
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows - WinAPI)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; basic definitions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc

        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
;==============================================================================================
.data
        szMsgText       db "Message", 0
        szMsgCaption    db "Dialog Caption", 0

; =============================================================================================
; Local prototypes
; ================
        WinMain         proto
        ShowMessage     proto szCaption:dword, szText:dword

; =============================================================================================
.code
start:
        invoke  WinMain
        invoke  ExitProcess, 1  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc            ; where working code is located
; code
        invoke  ShowMessage, addr szMsgText, addr szMsgCaption
        ret
WinMain         endp
; =============================================================================================
ShowMessage     proc    szText:dword, szCaption:dword

        invoke  MessageBox, NULL, szText, szCaption, MB_OK
        ret
ShowMessage     endp
; =============================================================================================
end     start
