; =============================================================================================
; _itoa() and ShowInt...
; =============================================================================================
; tabs  : 8 spaces (See Lesson_1 for beginning)
; ---------------------------------------------------------------------------------------------
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap:none    ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; ---------------------------------------------------------------------------------------------
; ++
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm

        ShowSeg macro   reg
                push    reg
                call    ShowHexInt
        endm
; =============================================================================================
; Prototypes
; ===========
        ShowInfo        proto lpszText:dword
        ShowMessage     proto lpszText:dword, lpszCaption:dword
; ++
        IntToString     proto value:dword, buffer:dword, base:dword
        ShowInteger     proto value:dword, base:dword

        ShowBinInt      proto value:dword
        ShowDecInt      proto value:dword
        ShowHexInt      proto value:dword
; =============================================================================================
; Local prototypes
; ================
        WinMain         proto
; =============================================================================================
; public and externals
; ======================
public  szMsgCaption    ; for Show...
extrn   szCmnBuffer     : byte
; =============================================================================================
.data
; Messages
        szMsgCaption    db "App Name", 0
        szIsFinished    db "Application is finished", 0
; Common
; =============================================================================================
.code
start:
        invoke  WinMain

        invoke  ShowInfo, addr szIsFinished
        invoke  ExitProcess, 0  ; program returns ... (0 - OK)
        ret                     ; 1 byte ending... (leave it here)
; =============================================================================================
; Local Procedures
; ================
WinMain         proc            ; where working code is located

        ; show some integer as string
        invoke  ShowHexInt, esp ; on the start

        invoke  ShowInt, 123    ;

;       invoke  ShowHexInt, ds  ; 16 bit register - problem with invoke...
        push    ds              ; 16 bit register - but it will occupy 4 bytes in the stack
        call    ShowHexInt      ;
; ->
        ShowSeg cs              ; see ShowSeg macro

        invoke  ShowHexInt, esi ; 32-bit register

        invoke  ShowHexInt, esp ; on the end
        ret
WinMain         endp
; =============================================================================================
; Helpers
; ==============
; in the ShowInfo.asm
; =============================================================================================
; Start point
end     start
