; =============================================================================================
; tabs : 8 spaces (MASM32 Packet: http://www.movsd.com/)
; ---------------------------------------------------------------------------------------------
; DllName.def file :
; ------------------
; LIBRARY DllName
; EXPORTS SomeProc1
;         SomeProc2
; ---------------------------------------------------------------------------------------------
; link options : /dll /subsystem:windows [/export:SomeProc]

; full command line: ([/Gz] - stdcall)
; /coff [/Gz] /Fe"Dll.dll" "Dll.asm" /link /dll /subsystem:windows [/export:SumInt /export:...]
; =============================================================================================
        .586                    ; from .386 32 bits code is the same upto Pentium (.486, .586P)
        .model  flat, stdcall   ; (tiny, small,...) (c, syscall,...)
        option  casemap: none   ; case sensitive (for windows)
; ---------------------------------------------------------------------------------------------
        include \masm32\include\kernel32.inc    ; operating system kernel functions
        include \masm32\include\windows.inc     ; common definitions (const, functions...)
        include \masm32\include\user32.inc      ; various user interface & other functions
        include \masm32\include\gdi32.inc       ; graphics related functions

        includelib \masm32\lib\gdi32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib     ; where .obj code is located or import library
; =============================================================================================
; Local macros
; ============
        m2m     macro   m1, m2                  ; memory to memory (source -> destination)
                push    m2
                pop     m1
        endm

        return  macro   arg
                mov     eax, arg
                ret
        endm
; =============================================================================================
; Local prototypes
; ================

; Global prototypes
; =================
        SumInt proto    a:dword, b:dword
        SubInt proto    a:dword, b:dword

; =============================================================================================
.data

; =============================================================================================
; Entry point
; ===========
.code
LibMain proc hInstDLL:dword, reason:dword, unused:dword

        .if reason == DLL_PROCESS_ATTACH

         mov    eax, TRUE
         ; -----------------------------
         ; If error at startup, return 0
         ; System will abort loading DLL
         ; -----------------------------

        .elseif reason == DLL_THREAD_ATTACH
        .elseif reason == DLL_THREAD_DETACH
        .elseif reason == DLL_PROCESS_DETACH

        .endif

        ret
LibMain endp
; =============================================================================================
; Global Procedures
; =================
SumInt  proc export a:dword, b:dword
; locals

; code
        mov     eax, a
        add     eax, b
        ret
SumInt  endp
; ---------------------------------------------------------------------------------------------
SubInt  proc export a:dword, b:dword
; locals

; code
        mov     eax, a
        sub     eax, b
        ret
SubInt  endp
; =============================================================================================
; Local Procedures
; ================

; =============================================================================================
; Start point
end     LibMain
